require File.dirname(__FILE__) + '/../../spec_helper'
require 'appengine-utils/datastore/blob'

describe AppEngineUtils::Datastore::Blob do
  
  before(:each) do
    @entity = AppEngineUtils::Datastore::Blob.new
  end
  
  def create_blob_dataset
    dataset = "\1" * 1000000
    key = @entity.create(dataset)
    key
  end
  
  it 'should create a new Blob Dataset' do
    key = create_blob_dataset
    key.should_not be_empty
  end
  
  it 'should read a existing Blob Dataset' do
    key = create_blob_dataset
    dataset = @entity.read(key)
    dataset.size.should ==("\1"*1000000).size 
  end
  
  it 'should update a existing Blob Dataset' do
    key = create_blob_dataset
    dataset = "\2" * 1000000
    
    new_key = @entity.update(key,dataset)
    new_dataset = @entity.read(new_key)
    new_dataset.should eql(dataset)
  end  
  
  it 'should delete a axisting Blob Dataset' do
    key = create_blob_dataset
    @entity.delete(key)
    dataset = @entity.read(key)
    dataset.should be_nil
  end
  
end